/*!
 * jQuery Quiz Plugin
 * https://github.com/Reload-Lab/jQuery-quiz
 *
 * @updated Sptemeber 29, 2023
 * @version 2.1.0
 *
 * @author Domenico Gigante <domenico.gigante@reloadlab.it>
 * @copyright (c) 2023 Reload Laboratorio Multimediale <info@reloadlab.it> (httpa://www.reloadlab.it)
 * @license MIT
 */
!function(e){var n={start:"Start",prev:"Back",next:"Forward",results:"Go to results",restart:"Back to the top",error:"Error",errmsg:["Please choose an answer.","Some questions have not been answered. Please, back to the top to answer all questions."]};e.quiz=e.fn.quiz=function(t){var s,i,o,a={},r=0,u=0,l=0,d="object"==typeof this?this.first():null,c="<div>",p="quiz-container",f="quiz-body",h="quiz-buttons",v="quiz-progress",m="quiz-modal",_="quiz_responses",q="quiz_flex",w="quiz_flexfill",g="quiz_num",b="quiz_alert",T="quiz_btn",z="quiz_response",y="quiz_progressbar",x='<i class="fa fa-play" aria-hidden="true"></i>',k='<i class="fa fa-step-backward" aria-hidden="true"></i>',B='<i class="fa fa-step-forward" aria-hidden="true"></i>',S='<i class="fa fa-repeat" aria-hidden="true"></i>',J='<i class="fa fa-thumbs-up" aria-hidden="true"></i>',D='<i class="fa fa-thumbs-down" aria-hidden="true"></i>',I={quizJson:null,cookieExpire:3600,hidePrevBtn:!1,hideRestartBtn:!1,fade:!0,randomQuestions:!1,numQuestions:null,onStep:function(e,n,t){t&&console.log(t)},onResults:function(e,n,t){console.log("results")},introTpl:'<div class="quiz_intro"><h2><%this.title%></h2><%if(this.description){%><p><%this.description%></p><%}%></div>',questionTpl:'<div class="'+q+'"><div class="'+g+'"><%this.question.__num%>.</div><div class="'+w+'"><h2><%this.question.question%></h2><%if(this.question.description){%><p><%this.question.description%></p><%}%><%for(var index in this.answers){%><div class="quiz_radiogroup"><input type="radio" id="answer-<%this.answers[index].__id%>" name="question<%this.question.__id%>" value="<%this.answers[index].__id%>" data-quiz-name="quizUID_<%this.question.__id%>" data-quiz-value="<%this.answers[index].__id%>"<%this.answers[index].__checked%>><label for="answer-<%this.answers[index].__id%>"><span></span> <%this.answers[index].answer%></label></div><%}%></div></div>',resultsTpl:'<div class="'+q+'"><div class="'+g+'"><%this.question.__num%>.</div><div class="'+w+'"><h2><%this.question.question%></h2><%if(this.question.description){%><p><%this.question.description%></p><%}%><%if(this.answer){%><div class="'+z+'"><strong><%this.answer.__num%>.</strong> <%this.answer.answer%></div><%if(this.answer.true == 1){%><div class="'+b+' quiz_success">'+J+'<%this.answer.alert%></div><%} else{%><div class="'+b+' quiz_fail">'+D+"<%this.answer.alert%></div><%}%><%}%></div></div>",startBtnTpl:'<button class="'+T+'"><%this.messages.start%>'+x+"</button>",prevBtnTpl:'<button class="'+T+'">'+k+"<%this.messages.prev%></button>",nextBtnTpl:'<button class="'+T+'"><%this.messages.next%>'+B+"</button>",resultBtnTpl:'<button class="'+T+'"><%this.messages.results%>'+B+"</button>",restartBtnTpl:'<button class="'+T+'">'+S+"<%this.messages.restart%></button>",modalBtnTpl:'<button class="'+T+'" data-dismiss="modal">'+S+"<%this.messages.restart%></button>",progressTpl:!1},O={localization:function(t){"object"==typeof t&&e.extend(n,t)}};if("string"==typeof t){if(O[t])return O[t].apply(this,Array.prototype.slice.call(arguments,1));t={quizJson:t}}if("object"==typeof t&&!t.quizJson){var E=d.data("quizJson");"string"==typeof E&&(t.quizJson=E)}function N(){try{if(!e(document).modal)throw new Error("Bootstrap 4 is required");if(!a.quizJson)throw new Error("Set url to quiz json file")}catch(e){console.error(e)}W(),e.getJSON(a.quizJson+"?_="+(new Date).getTime()).done((function(e,n,t){if(s=e[0].questions,a.randomQuestions&&(L(s),a.hidePrevBtn=!0),"number"==typeof a.numQuestions&&a.numQuestions<s.length&&(s=s.slice(0,parseInt(a.numQuestions))),i=e[0].intro||!1,r=s.length,!a.hidePrevBtn&&window.location.hash){var o=window.location.hash.substr(1).split("=")[1];/^\+?(0|[1-9]\d*)$/.test(o)?R(o-1):"results"==o&&C()}else j()})).fail((function(e,n,t){console.error("Fail"),console.error("Error "+n),console.error("Incoming Text "+e.responseText)}))}function P(){Z()&&(K("intro"),X("step_intro"),te(0))}function j(){a.fade?e("#"+f).fadeOut(300,(function(){P(),e("#"+f).fadeIn(300)})):P()}function Q(e){var n=$(e);n&&(K(e=n[0]+1),ee(n),X("step_"+e),te(e))}function R(n){a.fade?e("#"+f).fadeOut(300,(function(){Q(n),e("#"+f).fadeIn(300)})):Q(n)}function U(){K("results"),ne(),X("step_results"),te(r),"function"==typeof a.onResults&&a.onResults.apply(e("#"+p),[u,r,s])}function C(){a.fade?e("#"+f).fadeOut(300,(function(){U(),e("#"+f).fadeIn(300)})):U()}function $(e){return s[e]&&[e,s[e]]||null}function F(e,n,t){s[e][n]=t}function M(e,n){F(e,"__response",n)}function A(){var n={};return e.each(s,(function(e,t){t.__response&&(n["quizUID_"+e]=t.__response)})),n}function G(){e.each(s,(function(e,n){n.__response&&delete n.__response}))}function V(t){var i,o=JSON.parse(oe(_))||A(),r=!0;return o||(o={},ie(_,JSON.stringify(o),a.cookieExpire)),e.each(s,(function(e,s){return i="quizUID_"+e,e<t&&!o[i]?(se(n.errmsg[1],!0),r=!1,!1):e!=t||o[i]?void 0:(se(n.errmsg[0],!1),r=!1,!1)})),r}function H(n){var t=!0;return e.each(s,(function(e,s){e>n&&(t=!1)})),t}function K(e){if(!a.hidePrevBtn)switch(e){case"intro":o=null,window.location.hash="";break;case"results":o="results",window.location.hash="step=results";break;default:o=e,window.location.hash="step="+e}}function L(e){for(var n=e.length-1;n>0;n--){var t=Math.floor(Math.random()*(n+1)),s=e[n];e[n]=e[t],e[t]=s}}function W(){var n=e(c).prop("id",p).appendTo(d);e(c).prop("id",f).appendTo(n),e(c).prop("id",h).attr("role","group").appendTo(n),e(c).prop("id",v).appendTo(n)}function X(n){e("#"+p).removeClass().addClass(n)}function Y(){e("#"+f).empty(),e("#"+h).empty()}function Z(){if(Y(),i)return e(re(a.introTpl,i)).appendTo("#"+f),e(re(a.startBtnTpl,{messages:n})).appendTo("#"+h).on("click",(function(e){e.preventDefault(),R(l)})),!0;R(l)}function ee(t){Y();var i="quizUID_"+t[0],o=JSON.parse(oe(_))||A(),u=t[1];u.__id=t[0],u.__num=t[0]+1;var l=[];e.each(u.answers,(function(e,n){var t=n;t.__id=e,t.__num=e+1,t.__checked="",o&&o[i]&&o[i]==e&&(t.__checked=" checked"),l.push(t)})),$question=e(re(a.questionTpl,{question:u,answers:l})).appendTo("#"+f);try{var d=$question.find("[data-quiz-name]");if(!d.length)throw new Error("No response set!");d.on("click",(function(n){var s=JSON.parse(oe(_))||A(),i=e(this).data("quizName"),o=e(this).data("quizValue"),r={};r[i]=""+o,M(t[0],r[i]),e.extend(s,r),ie(_,JSON.stringify(s),a.cookieExpire)}))}catch(e){console.error(e)}a.hidePrevBtn||e(re(a.prevBtnTpl,{question:u,messages:n})).appendTo("#"+h).on("click",(function(n){n.preventDefault();var i=t[0];"function"==typeof a.onStep&&a.onStep.apply(e("#"+p),[i,r,s[i]]),i-1<0?j():R(i-1)})),H(t[0])?e(re(a.resultBtnTpl,{question:u,messages:n})).appendTo("#"+h).on("click",(function(n){n.preventDefault();var i=t[0];"function"==typeof a.onStep&&a.onStep.apply(e("#"+p),[i,r,s[i]]),V(i)&&C()})):e(re(a.nextBtnTpl,{question:u,messages:n})).appendTo("#"+h).on("click",(function(n){n.preventDefault();var i=t[0];"function"==typeof a.onStep&&a.onStep.apply(e("#"+p),[i,r,s[i]]),V(i)&&R(i+1)}))}function ne(){Y(),u=0;var t=JSON.parse(oe(_))||A();e.each(s,(function(n,s){var i="quizUID_"+n,o=s;o.__id=n,o.__num=n+1,e.each(s.answers,(function(e,n){t&&t[i]&&t[i]==e&&(answer=n,answer.__id=e,answer.__num=e+1,1==n.true&&u++)})),$question=e(re(a.resultsTpl,{question:o,answer:answer||!1})).appendTo("#"+f)})),a.hideRestartBtn||e(re(a.restartBtnTpl,{messages:n})).appendTo("#"+h).on("click",(function(e){e.preventDefault(),G(),ae(_),a.randomQuestions&&L(s),j()}))}function te(n){var t=n/r*100;if("string"==typeof a.progressTpl){var s={step:n,total:r,percent:t};e("#"+v).html(re(a.progressTpl,{progress:s}))}else{var i=e("#"+v).find("."+y);i.length||(i=e('<div class="'+y+'" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100"></div>').appendTo("#"+v)),i.attr("aria-valuenow",t).css("width",t+"%").html(n+"/"+r)}}function se(t,s){var i=e("#"+m);if(i.length)i.find(".modal-body").text(t).end().find(".modal-footer").css("display",s?"flex":"none").end().modal("show");else{var o='<div id="'+m+'" class="modal fade" role="dialog" aria-hidden="true" aria-labelledby="quiz_mdltitle" tabindex="-1"><div class="modal-dialog modal-dialog-centered" role="document"><div class="modal-content">';o+='<div class="modal-header"><h5 class="modal-title">'+n.error+'</h5><button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button></div>',o+='<div class="modal-body text-danger" aria-live="polite"></div>',o+='<div class="modal-footer"></div>',o+="</div>",o+="</div>",e(o+="</div>").appendTo("body"),a.hideRestartBtn||e(re(a.modalBtnTpl,{messages:n})).appendTo("#"+m+" .modal-footer").on("click",(function(e){e.preventDefault(),G(),ae(_),j()})),setTimeout((function(){se(t,s)}),10)}}function ie(e,n,t){var s="";if(t){var i=new Date;i.setTime(i.getTime()+1e3*t),s="; expires="+i.toUTCString()}document.cookie=e+"="+(n||"")+s+"; path=/"}function oe(e){for(var n=e+"=",t=document.cookie.split(";"),s=0;s<t.length;s++){for(var i=t[s];" "==i.charAt(0);)i=i.substring(1,i.length);if(0==i.indexOf(n))return i.substring(n.length,i.length)}return null}function ae(e){document.cookie=e+"=; Path=/; Expires=Thu, 01 Jan 1970 00:00:01 GMT;"}function re(e,n){var t,s,i=/<%(.+?)%>/g,o=/(^( )?(var|if|for|else|switch|case|break|{|}|;))(.*)?/g,a="with(obj) { var r=[];\n",r=0;function u(e,n){return a+=n?e.match(o)?e+"\n":"r.push("+e+");\n":""!=e?'r.push("'+e.replace(/"/g,'\\"')+'");\n':"",u}for(;s=i.exec(e);)u(e.slice(r,s.index))(s[1],!0),r=s.index+s[0].length;u(e.substr(r,e.length-r)),a=(a+'return r.join(""); }').replace(/[\r\t\n]/g," ");try{t=new Function("obj",a).apply(n,[n])}catch(e){console.error("'"+e.message+"'"," in \n\nCode:\n",a,"\n")}return t}return e.extend(a,I,t),e(window).bind("hashchange",(function(e){if(!a.hidePrevBtn)if(""!=window.location.hash||null==o){var n=window.location.hash.substr(1).split("=")[1];/^\+?(0|[1-9]\d*)$/.test(n)?parseInt(o)!=parseInt(n)&&R(n-1):"results"==n&&o!=n&&C()}else j()})),N(),this}}(jQuery);